module verilog_exec5(
    clk    ,
    rst_n  ,
    in0    ,
    in1    ,
    in2    ,
    out0   ,
    out1    
    );

    //
    parameter      DATA_W =         8;

    input               clk    ;
    input               rst_n  ;
    input [DATA_W-1:0]  in0    ;
    input [DATA_W-1:0]  in1    ;
    input [DATA_W-1:0]  in2    ;

    output[DATA_W-1:0]  out0   ;
    output[DATA_W-1:0]  out1   ;

    reg   [DATA_W-1:0]  out0   ;
    reg   [DATA_W-1:0]  out1   ;

    reg   [DATA_W-1:0]  sum0w    ;
    reg   [DATA_W-1:0]  sum1w    ;
    reg   [DATA_W-1:0]  out0_ff0 ;
    reg   [DATA_W-1:0]  out0_ff1 ;
    reg   [DATA_W-1:0]  out0_ff2 ;
    reg   [DATA_W-1:0]  out1_ff0 ;
    reg   [DATA_W-1:0]  out1_ff1 ;
    reg   [DATA_W-1:0]  out1_ff2 ;

    always@(*)begin
        sum0w = in0 + in1;
    end

    always  @(*)begin
        sum1w = in1 + in2;
    end


    always@(posedge clk or negedge rst_n)begin
        if(rst_n==1'b0)begin
            out0_ff0 <= 0;
        end
        else begin
            out0_ff0 <= sum0w;
        end
    end

    always  @(posedge clk or negedge rst_n)begin
        if(rst_n==1'b0)begin
            out0_ff1 <= 0;
        end
        else begin
            out0_ff1 <= out0_ff0;
        end
    end


    always  @(posedge clk or negedge rst_n)begin
        if(rst_n==1'b0)begin
            out0 <= 0;
        end
        else begin
            out0 <= out0_ff1;
        end
    end


    always@(posedge clk or negedge rst_n)begin
        if(rst_n==1'b0)begin
            out1_ff0 <= 0;
        end
        else begin
            out1_ff0 <= sum1w;
        end
    end

    always  @(posedge clk or negedge rst_n)begin
        if(rst_n==1'b0)begin
            out1_ff1 <= 0;
        end
        else begin
            out1_ff1 <= out1_ff0;
        end
    end


    always  @(posedge clk or negedge rst_n)begin
        if(rst_n==1'b0)begin
            out1 <= 0;
        end
        else begin
            out1 <= out1_ff1;
        end
    end



endmodule

